// $ANTLR : "E.g" -> "ELexer.java"$

package satc.lang; 

public interface ETokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int MLC_STAR = 4;
	int MLC_CLOSE = 5;
	int MLC_WORD = 6;
	int MLC_WS = 7;
	int LITERAL_int = 8;
	int LITERAL_uint = 9;
	int LITERAL_bit = 10;
	int LITERAL_byte = 11;
	int LITERAL_time = 12;
	int LITERAL_bool = 13;
	int LITERAL_string = 14;
	int LITERAL_locker = 15;
	int LITERAL_file = 16;
	int LITERAL_TRUE = 17;
	int LITERAL_FALSE = 18;
	int LITERAL_NULL = 19;
	int LITERAL_UNDEF = 20;
	int LITERAL_MAX_INT = 21;
	int LITERAL_MAX_UINT = 22;
	int LITERAL_MIN_INT = 23;
	int LITERAL_type = 24;
	int LITERAL_bits = 25;
	int LITERAL_bytes = 26;
	int LITERAL_as_a = 27;
	int LITERAL_var = 28;
	int LITERAL_not = 29;
	int LITERAL_and = 30;
	int LITERAL_or = 31;
	int LITERAL_in = 32;
	int LITERAL_is = 33;
	int LITERAL_a = 34;
	int LITERAL_while = 35;
	int LITERAL_do = 36;
	int LITERAL_for = 37;
	int LITERAL_from = 38;
	int LITERAL_down = 39;
	int LITERAL_to = 40;
	int LITERAL_step = 41;
	int LITERAL_each = 42;
	int LITERAL_using = 43;
	int LITERAL_index = 44;
	int LITERAL_matching = 45;
	int LITERAL_line = 46;
	int LITERAL_in_file = 47;
	int LITERAL_break = 48;
	int LITERAL_continue = 49;
	int LITERAL_if = 50;
	int LITERAL_then = 51;
	int LITERAL_else = 52;
	int LITERAL_case = 53;
	int LITERAL_default = 54;
	int LITERAL_all = 55;
	int LITERAL_of = 56;
	int LITERAL_struct = 57;
	int LITERAL_unit = 58;
	int LITERAL_like = 59;
	int LITERAL_extend = 60;
	int LITERAL_instance = 61;
	int LITERAL_when = 62;
	int LITERAL_init = 63;
	int LITERAL_pre_generate = 64;
	int LITERAL_post_generate = 65;
	int LITERAL_run = 66;
	int LITERAL_extract = 67;
	int LITERAL_quit = 68;
	int LITERAL_finalize = 69;
	int LITERAL_copy = 70;
	int LITERAL_do_print = 71;
	int LITERAL_print_line = 72;
	int LITERAL_do_pack = 73;
	int LITERAL_do_unpack = 74;
	int LITERAL_hdl_path = 75;
	int LITERAL_get_unit = 76;
	int LITERAL_get_enclosing_unit = 77;
	int LITERAL_try_enclosing_unit = 78;
	int LITERAL_first = 79;
	int LITERAL_also = 80;
	int LITERAL_only = 81;
	int LITERAL_sync = 82;
	int LITERAL_wait = 83;
	int LITERAL_until = 84;
	int LITERAL_result = 85;
	int LITERAL_return = 86;
	int LITERAL_start = 87;
	int LITERAL_check = 88;
	int LITERAL_that = 89;
	int LITERAL_dut_error = 90;
	int LITERAL_expect = 91;
	int LITERAL_set_check = 92;
	int LITERAL_ERROR = 93;
	int LITERAL_ERROR_BREAK_RUN = 94;
	int LITERAL_ERROR_AUTOMATIC = 95;
	int LITERAL_ERROR_CONTINUE = 96;
	int LITERAL_WARNING = 97;
	int LITERAL_IGNORE = 98;
	int LITERAL_cover = 99;
	int LITERAL_item = 100;
	int LITERAL_cross = 101;
	int LITERAL_transition = 102;
	int LITERAL_no_collect = 103;
	int LITERAL_at_least = 104;
	int LITERAL_global = 105;
	int LITERAL_text = 106;
	int LITERAL_weight = 107;
	int LITERAL_radix = 108;
	int LITERAL_DEC = 109;
	int LITERAL_BIN = 110;
	int LITERAL_HEX = 111;
	int LITERAL_ignore = 112;
	int LITERAL_illegal = 113;
	int LITERAL_ranges = 114;
	int LITERAL_range = 115;
	int LITERAL_mode = 116;
	int LITERAL_normal = 117;
	int LITERAL_count_only = 118;
	int LITERAL_pack = 119;
	int LITERAL_unpack = 120;
	int LITERAL_packing = 121;
	int LITERAL_high = 122;
	int LITERAL_high_big_endian = 123;
	int LITERAL_low = 124;
	int LITERAL_low_big_endian = 125;
	int LITERAL_network = 126;
	int LITERAL_swap = 127;
	int LITERAL_code = 128;
	int LITERAL_function = 129;
	int LITERAL_verilog = 130;
	int LITERAL_variable = 131;
	int LITERAL_net = 132;
	int LITERAL_wire = 133;
	int LITERAL_forcible = 134;
	int LITERAL_drive = 135;
	int LITERAL_hold = 136;
	int LITERAL_strobe = 137;
	int LITERAL_task = 138;
	int LITERAL_driver = 139;
	int LITERAL_disconnect = 140;
	int LITERAL_value = 141;
	int LITERAL_delay = 142;
	int LITERAL_INERTIAL = 143;
	int LITERAL_TRANSPORT = 144;
	int LITERAL_initial = 145;
	int LITERAL_interface = 146;
	int LITERAL_library = 147;
	int LITERAL_package = 148;
	int LITERAL_alias = 149;
	int LITERAL_declarative_item = 150;
	int LITERAL_procedure = 151;
	int LITERAL_force = 152;
	int LITERAL_release = 153;
	int LITERAL_event = 154;
	int LITERAL_emit = 155;
	int LITERAL_on = 156;
	int LITERAL_sys = 157;
	int LITERAL_any = 158;
	int LITERAL_tick_start = 159;
	int LITERAL_tick_end = 160;
	int LITERAL_new_time = 161;
	int LITERAL_session = 162;
	int LITERAL_start_of_test = 163;
	int LITERAL_end_of_test = 164;
	int LITERAL_change = 165;
	int LITERAL_rise = 166;
	int LITERAL_fall = 167;
	int LITERAL_sim = 168;
	int LITERAL_true = 169;
	int LITERAL_cycle = 170;
	int LITERAL_fail = 171;
	int LITERAL_eventually = 172;
	int LITERAL_detach = 173;
	int LITERAL_exec = 174;
	int LITERAL_consume = 175;
	int LITERAL_gen = 176;
	int LITERAL_keep = 177;
	int LITERAL_keeping = 178;
	int LITERAL_soft = 179;
	int LITERAL_prev = 180;
	int LITERAL_before = 181;
	int LITERAL_select = 182;
	int LITERAL_is_all_iterations = 183;
	int LITERAL_reset_soft = 184;
	int LITERAL_list = 185;
	int LITERAL_key = 186;
	int LITERAL_add = 187;
	int LITERAL_clear = 188;
	int LITERAL_delete = 189;
	int LITERAL_fast_delete = 190;
	int LITERAL_insert = 191;
	int LITERAL_pop = 192;
	int LITERAL_push = 193;
	int LITERAL_resize = 194;
	int LITERAL_all_indicies = 195;
	int LITERAL_apply = 196;
	int LITERAL_count = 197;
	int LITERAL_exists = 198;
	int LITERAL_first_index = 199;
	int LITERAL_get_indicies = 200;
	int LITERAL_has = 201;
	int LITERAL_is_a_permutation = 202;
	int LITERAL_is_empty = 203;
	int LITERAL_last = 204;
	int LITERAL_last_index = 205;
	int LITERAL_max = 206;
	int LITERAL_max_index = 207;
	int LITERAL_max_value = 208;
	int LITERAL_min = 209;
	int LITERAL_min_index = 210;
	int LITERAL_min_value = 211;
	int LITERAL_reverse = 212;
	int LITERAL_size = 213;
	int LITERAL_sort = 214;
	int LITERAL_sort_by_field = 215;
	int LITERAL_split = 216;
	int LITERAL_top = 217;
	int LITERAL_unique = 218;
	int LITERAL_and_all = 219;
	int LITERAL_average = 220;
	int LITERAL_or_all = 221;
	int LITERAL_product = 222;
	int LITERAL_sum = 223;
	int LITERAL_key_index = 224;
	int LITERAL_key_exists = 225;
	int LITERAL_out = 226;
	int LITERAL_outf = 227;
	int LITERAL_abs = 228;
	int LITERAL_odd = 229;
	int LITERAL_even = 230;
	int LITERAL_ilog = 231;
	int LITERAL_ipow = 232;
	int LITERAL_isqrt = 233;
	int LITERAL_div_round_up = 234;
	int LITERAL_bit_wise_and = 235;
	int LITERAL_bit_wise_or = 236;
	int LITERAL_bit_wise_xor = 237;
	int LITERAL_bit_wise_nand = 238;
	int LITERAL_bit_wise_nor = 239;
	int LITERAL_bit_wise_xnor = 240;
	int LITERAL_deep_copy = 241;
	int LITERAL_deep_compare = 242;
	int LITERAL_deep_compare_physical = 243;
	int LITERAL_append = 244;
	int LITERAL_appendf = 245;
	int LITERAL_bin = 246;
	int LITERAL_dec = 247;
	int LITERAL_hex = 248;
	int LITERAL_quote = 249;
	int LITERAL_str_chop = 250;
	int LITERAL_str_empty = 251;
	int LITERAL_str_exactly = 252;
	int LITERAL_str_expand_dots = 253;
	int LITERAL_str_insensitive = 254;
	int LITERAL_str_join = 255;
	int LITERAL_str_len = 256;
	int LITERAL_str_lower = 257;
	int LITERAL_str_match = 258;
	int LITERAL_str_pad = 259;
	int LITERAL_str_replace = 260;
	int LITERAL_str_split = 261;
	int LITERAL_str_split_all = 262;
	int LITERAL_str_sub = 263;
	int LITERAL_str_upper = 264;
	int LITERAL_to_string = 265;
	int LITERAL_set_config = 266;
	int LITERAL_get_config = 267;
	int LITERAL_write_config = 268;
	int LITERAL_read_config = 269;
	int LITERAL_set_keep = 270;
	int LITERAL_get_keep = 271;
	int LITERAL_with = 272;
	int LITERAL_specman = 273;
	int LITERAL_spawn = 274;
	int LITERAL_spawn_check = 275;
	int LITERAL_system = 276;
	int LITERAL_output_from = 277;
	int LITERAL_output_from_check = 278;
	int LITERAL_get_symbol = 279;
	int LITERAL_date_time = 280;
	int LITERAL_import = 281;
	int LITERAL_as = 282;
	int LITERAL_computed = 283;
	int LITERAL_define = 284;
	int LITERAL_lock = 285;
	int LITERAL_unlock = 286;
	int LITERAL_state = 287;
	int LITERAL_machine = 288;
	int LITERAL_files = 289;
	int LITERAL_open = 290;
	int LITERAL_read = 291;
	int LITERAL_write = 292;
	int LITERAL_read_lob = 293;
	int LITERAL_write_lob = 294;
	int LITERAL_close = 295;
	int LITERAL_flush = 296;
	int LITERAL_add_file_type = 297;
	int ID = 298;
	int TAB = 299;
	int BLANK = 300;
	int NEWLINE = 301;
	int LBRACK = 302;
	int RBRACK = 303;
	int DOT = 304;
	int SLICE = 305;
	int COLON = 306;
	int LPAREN = 307;
	int RPAREN = 308;
	int TILDE = 309;
	int EXCL = 310;
	int LCURLY = 311;
	int RCURLY = 312;
	int SEMI = 313;
	int COMMA = 314;
	int PLUS = 315;
	int MINUS = 316;
	int STAR = 317;
	int DIV = 318;
	int MOD = 319;
	int SHL = 320;
	int SHR = 321;
	int GT = 322;
	int LT = 323;
	int LE = 324;
	int GE = 325;
	int EQEQ = 326;
	int NEQ = 327;
	int EQEQEQ = 328;
	int NEQEQ = 329;
	int NMATCH = 330;
	int BXOR = 331;
	int BOR = 332;
	int BAND = 333;
	int LOR = 334;
	int LAND = 335;
	int SPD1 = 336;
	int QUESTION = 337;
	int AT = 338;
	int ACC = 339;
	int ACC2 = 340;
	int ESC = 341;
	int STRING_LITERAL = 342;
	int DEC = 343;
	int BIN = 344;
	int OCT = 345;
	int HEX = 346;
	int D_INT = 347;
	int B_INT = 348;
	int O_INT = 349;
	int H_INT = 350;
	int SIZED_D_INT = 351;
	int SIZED_B_INT = 352;
	int SIZED_O_INT = 353;
	int SIZED_H_INT = 354;
	int D_INT_OR_SIZED = 355;
	int CHAR_LITERAL = 356;
	int SL_COMMENT = 357;
	int DIRECTIVE = 358;
	int SYSTASK = 359;
	int MLC_OPEN = 360;
}
