// $ANTLR : "VHDLLexer.g" -> "VHDLLexer.java"$

package satc.lang; 

public interface VHDLTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int MLC_STAR = 4;
	int MLC_CLOSE = 5;
	int MLC_WORD = 6;
	int MLC_WS = 7;
	int LITERAL_abs = 8;
	int LITERAL_access = 9;
	int LITERAL_after = 10;
	int LITERAL_alias = 11;
	int LITERAL_all = 12;
	int LITERAL_and = 13;
	int LITERAL_architecture = 14;
	int LITERAL_array = 15;
	int LITERAL_assert = 16;
	int LITERAL_attribute = 17;
	int LITERAL_begin = 18;
	int LITERAL_block = 19;
	int LITERAL_body = 20;
	int LITERAL_buffer = 21;
	int LITERAL_bus = 22;
	int LITERAL_case = 23;
	int LITERAL_component = 24;
	int LITERAL_configuration = 25;
	int LITERAL_constant = 26;
	int LITERAL_disconnect = 27;
	int LITERAL_downto = 28;
	int LITERAL_else = 29;
	int LITERAL_elsif = 30;
	int LITERAL_end = 31;
	int LITERAL_entity = 32;
	int LITERAL_exit = 33;
	int LITERAL_file = 34;
	int LITERAL_for = 35;
	int LITERAL_function = 36;
	int LITERAL_generate = 37;
	int LITERAL_generic = 38;
	int LITERAL_group = 39;
	int LITERAL_guarded = 40;
	int LITERAL_if = 41;
	int LITERAL_impure = 42;
	int LITERAL_inout = 43;
	int LITERAL_in = 44;
	int LITERAL_inertial = 45;
	int LITERAL_is = 46;
	int LITERAL_label = 47;
	int LITERAL_library = 48;
	int LITERAL_linkage = 49;
	int LITERAL_literal = 50;
	int LITERAL_loop = 51;
	int LITERAL_map = 52;
	int LITERAL_mod = 53;
	int LITERAL_nand = 54;
	int LITERAL_new = 55;
	int LITERAL_next = 56;
	int LITERAL_nor = 57;
	int LITERAL_not = 58;
	int LITERAL_null = 59;
	int LITERAL_of = 60;
	int LITERAL_on = 61;
	int LITERAL_open = 62;
	int LITERAL_or = 63;
	int LITERAL_others = 64;
	int LITERAL_out = 65;
	int LITERAL_package = 66;
	int LITERAL_port = 67;
	int LITERAL_postponed = 68;
	int LITERAL_procedure = 69;
	int LITERAL_process = 70;
	int LITERAL_pure = 71;
	int LITERAL_range = 72;
	int LITERAL_record = 73;
	int LITERAL_register = 74;
	int LITERAL_reject = 75;
	int LITERAL_rem = 76;
	int LITERAL_report = 77;
	int LITERAL_return = 78;
	int LITERAL_rol = 79;
	int LITERAL_ror = 80;
	int LITERAL_select = 81;
	int LITERAL_severity = 82;
	int LITERAL_sla = 83;
	int LITERAL_sll = 84;
	int LITERAL_sra = 85;
	int LITERAL_srl = 86;
	int LITERAL_shared = 87;
	int LITERAL_signal = 88;
	int LITERAL_subtype = 89;
	int LITERAL_then = 90;
	int LITERAL_to = 91;
	int LITERAL_transport = 92;
	int LITERAL_type = 93;
	int LITERAL_units = 94;
	int LITERAL_until = 95;
	int LITERAL_unaffected = 96;
	int LITERAL_use = 97;
	int LITERAL_variable = 98;
	int LITERAL_wait = 99;
	int LITERAL_when = 100;
	int LITERAL_while = 101;
	int LITERAL_with = 102;
	int LITERAL_xor = 103;
	int LITERAL_xnor = 104;
	int ATTRIB = 105;
	int TAB = 106;
	int BLANK = 107;
	int NEWLINE = 108;
	int SL_COMMENT = 109;
	int MLC_OPEN = 110;
	int AT = 111;
	int COLON = 112;
	int COMMA = 113;
	int DOT = 114;
	int ASSIGN = 115;
	int MINUS = 116;
	int LBRACK = 117;
	int RBRACK = 118;
	int LCURLY = 119;
	int RCURLY = 120;
	int LPAREN = 121;
	int RPAREN = 122;
	int POUND = 123;
	int QUESTION = 124;
	int SEMI = 125;
	int PLUS = 126;
	int LNOT = 127;
	int BNOT = 128;
	int BAND = 129;
	int RNAND = 130;
	int BOR = 131;
	int RNOR = 132;
	int BXOR = 133;
	int RXNOR = 134;
	int STAR = 135;
	int DIV = 136;
	int MOD = 137;
	int EQUAL = 138;
	int NOT_EQ = 139;
	int NOT_EQ_CASE = 140;
	int EQ_CASE = 141;
	int LAND = 142;
	int LOR = 143;
	int LT_ = 144;
	int LE = 145;
	int GT = 146;
	int GE = 147;
	int SR = 148;
	int SL = 149;
	int TRIGGER = 150;
	int PPATH = 151;
	int FPATH = 152;
	int IDENTIFIER = 153;
	int ESCAPED_IDENTIFIER = 154;
	int SYSTEM_TASK_NAME = 155;
	int STRING = 156;
	int DEFINE = 157;
	int VOCAB = 158;
	int SIZED_NUMBER = 159;
	int SIZE = 160;
	int BASE = 161;
	int SIZED_DIGIT = 162;
	int UNSIZED_NUMBER = 163;
	int DIGIT = 164;
	int HEXDIGIT = 165;
	int EXPONENT = 166;
}
